unit Main;

{$mode objfpc}{$H+}

interface

uses
  ComCtrls, SysUtils, db, DBGrids, memds, Forms, Classes,
  TADbSource, TAGraph, TASeries, TAIntervalSources;

type

  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    Chart1LineSeries1: TLineSeries;
    Chart1LineSeries2: TLineSeries;
    Datasource1: TDatasource;
    DateTimeIntervalChartSource1: TDateTimeIntervalChartSource;
    DbChartSource1: TDbChartSource;
    DbChartSource2: TDbChartSource;
    DBGrid1: TDBGrid;
    SensorsTbl: TMemDataset;
    procedure FormCreate(Sender: TObject);
  end;

var
  Form1: TForm1; 

implementation

{$R *.lfm}

{ TForm1 }

{ Add dummy data to start with }
procedure TForm1.FormCreate(Sender: TObject);
const
  N = 60;
var
  i: Integer;
  dt: TDateTime;
begin
  SensorsTbl.DisableControls;
  try
    for i:=1 to N do begin
      SensorsTbl.Append;
      // create a dummy date within the past N days
      dt := Date() - N + i;
      SensorsTbl.FieldByName('DateA').AsDateTime := Now() - N + i - random;
      // SensorA is supposed to measure a constant value (room temperature) with some noise
      SensorsTbl.FieldByName('SensorA').AsFloat := 21 + random;
      // SensorB measures the out-side temperature which is ranging here linearly
      // between 15 and 25 degrees, with some noise
      SensorsTbl.FieldByName('SensorB').AsFloat := 10 * (i/N) + 15 + random;
      // The measurement of Sensor A is taken at some time during the dummy date
      SensorsTbl.FieldByName('DateA').AsDateTime := dt + random;
      // Sensor B as well
      SensorsTbl.FieldByName('DateB').AsDateTime := dt + random;
      // Post to database
      SensorsTbl.Post;
    end;
  finally
    SensorsTbl.EnableControls;
  end;
end;

end.

